//O[o
float4 Color = float4(1, 1, 1, 1);
texture InputTex;//eNX`
float2 TexelSize;//eNZTCY


sampler InputSmp = sampler_state{
	Texture = < InputTex >;//͂̃eNX`
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};


//2D`PS
float4 NormalPs(float2 _UV:TEXCOORD0) :COLOR0{

	_UV += TexelSize * 0.5;//UVW𔼃sNZ炷


	return tex2D(InputSmp, _UV)*Color;
}


technique NormalTech{
	pass P0{
		PixelShader = compile ps_3_0 NormalPs();

		ZEnable = false;
		ZWriteEnable = false;
	}
}


/////////////////////////////////////////////////////////////////////////////

float4 BlurPs(float2 _UV:TEXCOORD0) :COLOR0{

	_UV += TexelSize * 0.5;//UVW𔼃sNZ炷
	float3 color = 0;
	color = tex2D(InputSmp, _UV).xyz;
	color += tex2D(InputSmp, _UV + float2(-TexelSize.x, 0)).xyz;
	color += tex2D(InputSmp, _UV + float2(TexelSize.x, 0)).xyz;
	color += tex2D(InputSmp, _UV + float2(0, -TexelSize.y)).xyz;
	color += tex2D(InputSmp, _UV + float2(0, TexelSize.y)).xyz;
	color *= 0.2;


	return float4(color, 1);

}


technique BlurTech{
	pass P0{
		PixelShader = compile ps_3_0 BlurPs();
		ZEnable = false;
		ZWriteEnable = false;
	}
}

//////////////////////////////ڂPS/////////////////////////////////


float4 XBlurPs(float2 _UV:TEXCOORD0) :COLOR0{
	_UV += TexelSize * 0.5;//UVW𔼃sNZ炷
	float3 color = 0;
		color = tex2D(InputSmp, _UV).xyz;
	for (int i = 1; i < 3; i++){
		color += tex2D(InputSmp, _UV + float2(-TexelSize.x * i, 0)).xyz;
		color += tex2D(InputSmp, _UV + float2(TexelSize.x * i, 0)).xyz;
	}
	color /= 11;
	return float4(color, 1);
}


technique XBlurTech{
	pass P0{
		PixelShader = compile ps_3_0 XBlurPs();
		ZEnable = false;
		ZWriteEnable = false;
	}
}

//////////////////////////////cڂPS///////////////////////////////

float4 YBlurPs(float2 _UV:TEXCOORD0) :COLOR0{
	_UV += TexelSize * 0.5;
	float3 color = 0;
		color = tex2D(InputSmp, _UV).xyz;
	for (int i = 1; i < 5; i++){
		color += tex2D(InputSmp, _UV + float2(0, -TexelSize.y * i)).xyz;
		color += tex2D(InputSmp, _UV + float2(0, TexelSize.y * i)).xyz;
	}
	color /= 11;
	return float4(color, 1);


}


technique YBlurTech{
	pass P0{
		PixelShader = compile ps_3_0 YBlurPs();
		ZEnable = false;
		ZWriteEnable = false;
	}
}