//O[o
float4x4 mW;    //[hs
float4x4 mV;    //r[s
float4x4 mP;    //ˉes
float4 Diffuse = float4(1, 1, 1, 1);//̐F RGBA
float3 LightDir = float3(1, -1, 0);

float4 Color = float4(1, 1, 1, 1);
float4 Specular = float4(1, 1, 1, 1);//XyL[̐F
float Power = 50;//XyL[̉s
float Ambient = 0.3;//̗


texture DrawTex;//`eNX`
texture NormalTex;//@eNX`
float3 CamPos;//J̍W


//G`1(`悷)
sampler DrawSmp = sampler_state{
	Texture = < DrawTex >;//͂̃eNX`
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};

//G`2(F@ƂĈ)
sampler NormalSmp = sampler_state{
	Texture = < NormalTex >;//͂̃eNX`
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};


//_VF[_o͗p\
struct VS_OUT{
	float4 Pos:POSITION;  //
	float3 wN:TEXCOORD0;	//@
	float2 MeshUV:TEXCOORD1;//bVUVW
	float3 wPos:TEXCOORD2;//
};


//_VF[_
VS_OUT MyVS(float4 pos:POSITION, float3 normal : NORMAL, float2 uv : TEXCOORD0){         //3D[JW,@xNg,eNX`UVW

	VS_OUT Out;//\̕ϐ쐬
	//2Dϊ
	Out.Pos = mul(pos, mW);
	Out.wPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mV);
	Out.Pos = mul(Out.Pos, mP);

	Out.wN = normalize(mul(normal, (float3x3)mW));
	Out.MeshUV = uv;

	return Out;
}




//sNZVF[_o͗p\
struct PS_OUT{
	float4 Color:COLOR0;
};

//sNZVF[_
PS_OUT MyPS(VS_OUT In){

	float3 w_normal = normalize(In.wN);
	
	float4 Col = Diffuse * tex2D(DrawSmp, In.MeshUV);//w肳ꂽeNX`UVW̐Fɂ傲ɂ


	PS_OUT Out;

	Out.Color = Col;

	return Out;
}


technique MyTech{
	pass P0{
		VertexShader = compile vs_3_0 MyVS();    //gp钸_VF[_
		PixelShader = compile ps_3_0 MyPS();
	}
}

