//O[o萔     VClĂ
float4x4 mW;    //[hs
float4x4 mV;    //r[s
float4x4 mP;    //ˉes
float4 Diffuse = float4(1, 1, 1, 1);//̐F RGBA
float3 LightDir = float3(1, -1, 0);

float4 Specular = float4(1, 1, 1, 1);//XyL[̐F
float Power = 50;//XyL[̉s
float Ambient = 0.3;//̗
float3 CamPos;//J̍W

texture MeshTex;//}eÃeNX`




//MeshTexpTv
sampler MeshSmp = sampler_state{
	Texture = < MeshTex >;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};





//_VF[_o͗p\
struct VS_OUT{
	float4 Pos:POSITION;  //2DW
	float3 wN:TEXCOORD0;
	float2 MeshUV:TEXCOORD1;
	float3 wPos:TEXCOORD2;//3DW   m[gɃsNZPos@ďĂ
};

//_VF[_
VS_OUT VS(float4 pos:POSITION, float3 normal : NORMAL, float2 uv : TEXCOORD0){         //3D[JW,@xNg,eNX`UVW

	VS_OUT Out;
	//2Dϊ
	Out.Pos = mul(pos, mW);
	Out.wPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mV);
	Out.Pos = mul(Out.Pos, mP);

	Out.wN = normalize(mul(normal, (float3x3)mW));
	Out.MeshUV = uv;

	return Out;
}

//sNZVF[_o͗p\
struct PS_OUT{
	float4 Color:COLOR0;
};

//sNZVF[_
PS_OUT PS(VS_OUT In){

	float3 w_normal = normalize(In.wN);
	float LPow = dot(-LightDir, w_normal);
	float4 Col = Diffuse * tex2D(MeshSmp,In.MeshUV);
	LPow = max(0, LPow);




	//CeBOKp
	Col.rgb *= min(1,LPow + Ambient);//̋
		




	//X؃L
	float3 vCam = normalize(CamPos - In.wPos);
	float3 vRef = 2 * dot(w_normal, -LightDir) * w_normal + LightDir;
	float SpePow = dot(vRef,vCam);
	SpePow = max(0,SpePow);
	SpePow = pow(SpePow, Power);//pow(a,b) ab悷
	float4 Spe = Specular * SpePow;

	//
	//float4 Col2 = Col;
	//Col2 = pow(Col2, 10);
	//Col2.r = min(Col2.r, Col.r);
	//Col2.g = min(Col2.g, Col.g);
	//Col2.b = min(Col2.b, Col.b);



	//܂
	PS_OUT Out;

	//Out.Color = Col + Spe;
	Out.Color = Col + Spe;
	//


	//Out.Color = float4(0, 0, 0, 1);
	return Out;
}


technique Tech{
	pass P0{
		VertexShader = compile vs_3_0 VS();    //gp钸_VF[_
		PixelShader = compile ps_3_0 PS();	   //gpsNZVF[_
	}
}

/////////////////////////////////////                                           ֊s                                         //////////////////////////////////////////////


float4 OntLineColor = float4(1, 0, 0, 1);//֊sF
float  OutLineSize = 0.30;				 //֊s̑傫


//_VF[_o͗p\
struct OUTLINE_VS_OUT{
	float4 Pos:POSITION;  //W  Z}eBbNXiprŎgpČ^Oj
};

//_VF[_
OUTLINE_VS_OUT OUTLINE_VS(float4 pos:POSITION, float3 normal : NORMAL){         //3D[JW,@xNg

	OUTLINE_VS_OUT Out;

	//@ւ炷
	float3 newPos = pos.xyz + normal * OutLineSize;//@̂܂܂炷Ƃ[łȂ̂Ŋ|ďB

		//2Dϊ
		Out.Pos = mul(float4(newPos, 1), mW);// x y z + 1ŌvZ@ȒPɌƁ@float3  float4ɕςB
	Out.Pos = mul(Out.Pos, mV);

	Out.Pos = mul(Out.Pos, mP);//ˉeWn

	return Out;
}

//sNZVF[_o͗p\
struct OUTLINE_PS_OUT{
	float4 Color:COLOR0;
};

//sNZVF[_
float4 OUTLINE_PS(OUTLINE_VS_OUT In) :COLOR0
{
	return OntLineColor;
}

//eNjbN gpo[WBBBCB
technique OutLine_Tech{
	pass P0{
		VertexShader = compile vs_3_0 OUTLINE_VS();    //gp钸_VF[_
		PixelShader = compile ps_3_0 OUTLINE_PS();	   //gpsNZVF[_
		CullMode = CW;//\ʃJOł@@
	}
}